/* INFOH302 - TP04-05 - Exercice 2: Template Method
* 
*  Écrire plusieurs classes Logger qui enregistrent des messages de type String. 
*  Chaque entrée du log comprend un timestamp (JJ/MM/AAAA hh:mm:ss) suivi du message.
*  Le Logger ajoute une double, respectivement simple, ligne de séparation si la date,
*  respectivement l’heure (hh), a changé par rapport à la précédente entrée.
*  Les classes sont :
*   - FileLogger
*   - ConsoleLogger
*  Illustrer par un exemple (main).
 */

import java.util.Date;

public abstract class Logger {
    private Date lastLog;

    protected abstract void record(String message);

    public void log(String message) {
		Date now = new Date();
        if(lastLog==null || lastLog.getDate()!=now.getDate())
            this.record("=================\n================");
        else if(lastLog==null || lastLog.getSeconds()!=now.getSeconds()) 
            this.record("=================="); // if seconds are different so that we can test it. 
        this.record(now.toString() + ": " + message);
        this.lastLog = now;
    }

    public static void main(String[] args) throws InterruptedException
    {
		ConsoleLogger l = new ConsoleLogger();
		l.log("message 1");
        l.log("message 2");
        try {
        	Thread.sleep(2000);
		} catch ( InterruptedException ignored) {}
        l.log("Message 3 (later)");
    }

}


