/* INFOH302 - TP04-05 - Exercice 3: Observer
*
*  Implémenter les classes suivantes :
*   (i) WeatherServer : capte la température et l'ensoleillement 
*     (“tempête”,  “pluie”, “nuageux”, “nuages épars”, “éclaircies”, “soleil”). 
*     On simulera ce serveur avec des méthodes get et set pour changer l'état 'capté'.
*   (ii) SimpleWeatherClient :
*	 - s'enregistre auprès du WeatherServer
*	 - imprime sur la console la température et l'ensoleillement 
*      chaque fois qu'il y a un changement. 
*   (iii) SuperWeatherClient :
*    - s'enregistre auprès du server
*    - imprime sur la console l'heure, la date, la température et l'ensoleillement
*      chaque fois qu'il y a un changement, accompagné d’un smiley :-) s'il fait beau,
*      :-( dans les autres cas.
*
*    Chaque client (chaque SimpleWeatherClient et chaque SuperWeatherClient) porte un nom.
*    Le message qu'il imprime est toujours précédé de son nom.
*/

public class SuperWeatherClient implements Observer {
    WeatherServer weather;
    String name;

    public SuperWeatherClient(WeatherServer weather, String name) {
        this.weather = weather;
        weather.attach(this);
        this.name = name;
    }

    public void update() {
        String sun = this.weather.getSun();
        System.out.print(this.name+": "+new java.util.Date()+" - "+this.weather.getTemp()+", "+sun);
		if(sun.equals("soleil"))
			System.out.println(":-)");
        else System.out.println(":-(");
    }

    public static void main(String[] args)
    {
		WeatherServer ws = new WeatherServer();
        SuperWeatherClient super1 = new SuperWeatherClient(ws, "monSuperClient1");
        SuperWeatherClient super2 = new SuperWeatherClient(ws, "monSuperClient2");
        SimpleWeatherClient simple1 = new SimpleWeatherClient(ws, "monSimpleClient1");
        ws.setWeather("nuageux", 5);
        try {
        	Thread.sleep(2000);
		} catch ( InterruptedException ignored) {}
        ws.setWeather("soleil", 25);
    }
}
