/* INFOH302 - TP04-05 - Exercice 4: Composite */

public abstract class Operation implements Expression{

	protected Expression rightExp;
	protected Expression leftExp;

	protected Operation(Expression leftExp, Expression rightExp) {
		this.rightExp = rightExp;
		this.leftExp = leftExp;
	}

	public ExpressionIterator iterator() {
		return new OperationIterator(leftExp, this, rightExp);
	}
	public ExpressionIterator fasterIterator() {
		return new FasterExpressionIterator(this);
	}
	public abstract double evaluate() ;

	public abstract String opString();
	public String atomString() {return opString();}
	public Expression getLeft() {return leftExp;}
	public Expression getRight() {return rightExp;}
}
