/* INFOH302 - TP04-05 - Exercice 4: Composite */

import java.util.NoSuchElementException;

public class OperationIterator implements ExpressionIterator {

	private Operation op;
	private ExpressionIterator leftIt;
	private ExpressionIterator rightIt;
	private boolean beforeExpression = true;
	private boolean afterExpression = false;
	

	public OperationIterator(Expression left, Operation operator, Expression right) {
		this.leftIt = left.iterator();
		this.rightIt = right.iterator();
		this.op = operator;
	}

	public boolean hasNext() {
		return !afterExpression;
	}

	public String next() {
		if(beforeExpression) {
			beforeExpression = false;
			return "(";
		} else if(leftIt.hasNext()) {
			return leftIt.next();
		} else if (op!= null) {
			Operation next = op;
			op = null;
			return next.opString();
		} else if(rightIt.hasNext()) {
			return rightIt.next();
		} else if (!afterExpression) {
			afterExpression = true;
			return ")";
		} else {
			throw new NoSuchElementException();
		}
	}
}
