/* INFOH302 - TP04-05 - Exercice 4: Composite 
*
*  Écrire des classes permettant de représenter des expressions et de les évaluer. 
*  Une expression est de la forme "expression + opérateur + expression"  ou "nombre". 
*  Les nombres sont des nombres entiers, les opérateurs sont l’addition, soustraction,
*  multiplication et division.
*  Ajouter une méthode permettant d'obtenir un itérateur énumérant 
*  l'expression de gauche à droite. 
*/

public class TestExpression {
	public static void main(String[] args) {
		// ((1+2)*(4-3))/2 == 1.5 ?
		Expression ex1 = new Number(1);
		Expression ex2 = new Number(2);
		Expression ex3 = new Number(3);
		Expression ex4 = new Number(4);
		Expression plus = new PlusOperation(ex1, ex2);
		Expression minus = new MinusOperation(ex4, ex3);
		Expression mul = new MultiplyOperation(plus, minus);
		Expression div = new DivideOperation(mul, ex2);
		System.out.println(div.evaluate());
		StringBuffer sb = new StringBuffer();
		for(ExpressionIterator it = div.iterator(); it.hasNext();) {
			sb.append(it.next());
		}
		System.out.println(sb);
		sb = new StringBuffer();
		for(ExpressionIterator it = div.fasterIterator(); it.hasNext();) {
			sb.append(it.next());
		}
		System.out.println(sb);
		
		int depth = 50000;
		System.out.println("Speed Test: Building expression of depth " + depth);
		Expression bigExpression = new Number(1);
		for(int i=0; i<depth; i++) {
			bigExpression = new PlusOperation(bigExpression, new Number(1));
		}
		System.out.println("With FasterExpressionIterator");
		sb = new StringBuffer();
		for(ExpressionIterator it = bigExpression.fasterIterator(); it.hasNext();) {
			sb.append(it.next());
		}
		System.out.println("Done");

		System.out.println("With ExpressionIterator");
		sb = new StringBuffer();
		for(ExpressionIterator it = bigExpression.iterator(); it.hasNext();) {
			sb.append(it.next());
		}
		System.out.println("Done");
		
		
	}
}
